/*
 * Copyright (c) 2016-2017, Parallels International GmbH
 *
 * This file is part of disp-helper. It's free software; you can redistribute
 * it and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 *
 * Our contact details: Parallels International GmbH, Vordergasse 59, 8200
 * Schaffhausen, Switzerland.
 */

#include "Utils.hpp"
#include "Server.hpp"
#include "DbLayer.hpp"
#include "Client.hpp"

int main(int argc, char* argv[])
{
	if (!Utils::Init(argc, argv))
		exit(EXIT_FAILURE);

	if (Utils::GlobalSettings().get<bool>("server", false)) {
#ifdef __SERVER_SIDE__
		Database::Db::Instance().Connect();
		Server::Collector i(Utils::Base::Instance().IoService());
		Utils::Base::Instance().Run();
#endif // __SERVER_SIDE__
	} else {
		Client::Collector c(Utils::Base::Instance().IoService());
		c.Run();
		Utils::Base::Instance().Run();
	}
	return EXIT_SUCCESS;
}
